#include "testlib.h"

using namespace std;

int n;
long long T;
vector<int> p;
vector<long long> t, a;
vector<vector<int>> g;

long long dfs(int v, long long d) {
    long long ans = a[v] + 1;
    for (int u : g[v]) {
        if (t[u] <= d) {
            ans += dfs(u, d - t[u]);
        }
    }
    return ans;
}

long long check(InStream &in) {
    int v = in.readInt(1, n, "v") - 1;
    long long total = in.readLong(0, LLONG_MAX, "total");
    long long actual = dfs(v, T);
    if (actual != total) in.quitf(_wa, "Total number of people is not correct for selected person");
    return actual;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    T = inf.readInt();
    p.assign(n, 0);
    t.assign(n, 0);
    a.assign(n, 0);
    for (int i = 1; i < n; i++) p[i] = inf.readInt() - 1;
    for (int i = 1; i < n; i++) t[i] = inf.readInt();
    for (int i = 0; i < n; i++) a[i] = inf.readInt();
    g.resize(n);
    for (int i = 1; i < n; i++) {
        g[p[i]].push_back(i);
    }

    long long ja = check(ans), pa = check(ouf);
    if (ja < pa) {
        quitf(_fail, "Participant has better answer");
    } else if (ja > pa) {
        quitf(_wa, "Jury has better answer");
    }

    quitf(_ok, "all checks passed");

}